<?php defined('C5_EXECUTE') or die("Access Denied.");?>

<?php $app = \Concrete\Core\Support\Facade\Application::getFacadeApplication();?>

<h1><?php echo t('Used Areas');?></h1>


<div class="row">
    <div class="col-sm-6">
        <div id="tree">

        </div>
    </div>
    <div class="col-sm-6">
        <div id="area-preview" style="display: none; overflow-y: scroll!important;max-height: 90vh!important;">
            <h1 ><?php echo t('Page Preview');?>: <span class="page-name"></span> </h1>
            <div class="area-content">
            </div>
        </div>
    </div>
</div>



<script>

    $(function () {
        $('body').append('<div class="ccm-ui" id="ccm-popover-menu-container"></div>');

        $.fn.areasTree = function(){
            this.fancytree({
                tabindex: null,
                titlesTabbable: false,
                extensions: ["glyph", "dnd"],
                source: <?php echo json_encode($treeViewData);?>,
                chooseNodeInForm: true,
                glyph: {
                    map: {
                        doc: "fa fa-file-o",
                        docOpen: "fa fa-file-o",
                        checkbox: "fa fa-square-o",
                        checkboxSelected: "fa fa-check-square-o",
                        checkboxUnknown: "fa fa-share-square",
                        dragHelper: "fa fa-share",
                        dropMarker: "fa fa-angle-right",
                        error: "fa fa-warning",
                        expanderClosed: "fa fa-plus-square-o",
                        expanderLazy: "fa fa-plus-square-o",  // glyphicon-expand
                        expanderOpen: "fa fa-minus-square-o",  // glyphicon-collapse-down
                    }
                },
            });
            this.on('click', '.area-handle', function(e){
                e.preventDefault();

                var $menu = $('#areaContextMenu');
                var handle = $(this).attr('data-area-handle');
                var _menuTemplate =_.template($('#areaContextMenuTemplate').html());
                var treeNode = $(this).closest('li');

                $('#ccm-popover-menu-container').html('');
                $('#ccm-popover-menu-container').append(_menuTemplate({handle : handle}));


                $('#areaContextMenu')
                    .show()
                    .css({
                        position: "absolute",
                        left: getMenuPosition('#areaContextMenu', e.clientX, 'width', 'scrollLeft'),
                        top: getMenuPosition('#areaContextMenu', e.clientY, 'height', 'scrollTop'),
                        opacity : 1
                    });
                $('#ccm-popover-menu-container #areaContextMenu a').click(function(e){
                    e.stopPropagation();
                    $('#areaContextMenu').hide();
                    var areaHandle =  $(this).attr('data-area-handle');
                    jQuery.fn.dialog.showLoader();
                    $.ajax({
                        type: 'GET',
                        dataType: 'json',
                        url: '<?php echo $view->action('area_pages_count'); ?>/' + areaHandle,
                        success: function (data) {
                            jQuery.fn.dialog.hideLoader();
                            var approvedCount = 0;
                            var notApprovedCount = 0;

                            var message = '';
                            if(data!=undefined){
                                approvedCount = parseInt(data.numberOfApprovedVersions);
                                notApprovedCount = parseInt(data.numberOfNotApprovedVersions);
                                message = data.message;
                            }

                            ConcreteAlert.confirm(
                                (approvedCount + notApprovedCount) > 0 ?  message : '<?php echo t('Are you sure you want to delete area ')?> ' + areaHandle,
                                function() {
                                    $.ajax({
                                        type: 'POST',
                                        dataType: 'json',
                                        data:{
                                            area_handle:areaHandle

                                        },
                                        url: '<?php echo $view->action('delete_area'); ?>',
                                        success: function(data) {

                                            treeNode.remove();
                                            ConcreteAlert.notify({
                                                'message': '<?php echo t('Area is deleted');?>',
                                            });
                                        },
                                        error:function (data) {
                                            console.log(data);
                                            ConcreteAlert.error({
                                                title: '',
                                                message: data
                                            });
                                        },

                                    }).done(function(){
                                        $('#areaContextMenu').hide();
                                    });
                                    $('#ccm-popup-confirmation').remove();
                                },
                                'btn-danger',
                              <?php echo json_encode(t('Delete')); ?>
                            );
                        }
                    })
                });
                return false;
            });
            this.on('click', '.page-name', function(e){
                e.stopPropagation();
                var cID = $(this).attr('data-cID');
                var url = $(this).attr('data-url');
                var areaHandle = $(this).attr('data-area-handle');
                var _menuTemplate = _.template($('#pageContextMenuTemplate').html());
                var pageName = $(this).attr('data-page-name');
                var blocksCount = parseInt($(this).attr('data-blocks-count'));
                $('#ccm-popover-menu-container').html('');
                $('#ccm-popover-menu-container').append(
                    _menuTemplate({cID : cID, url : url, areaHandle :areaHandle, pageName:pageName, blocksCount : blocksCount})
                );

                $('#pageContextMenu')
                    .show()
                    .css({
                        position: "absolute",
                        left: getMenuPosition('#areaContextMenu', e.clientX, 'width', 'scrollLeft'),
                        top: getMenuPosition('#areaContextMenu', e.clientY, 'height', 'scrollTop'),
                        opacity : 1
                    });
                $('#pageContextMenu').on('click', 'a', function(e){
                    $('#pageContextMenu').hide();
                    var action = $(this).attr('data-action');
                    var title = $(this).html();
                    var areaHandle = $(this).attr('data-area-handle');
                    var pageName = $(this).attr('data-page-name');

                    if(action == 'design'){
                        var url = $(this).attr('dialog-url');
                        jQuery.fn.dialog.open({
                            title: title,
                            href: url,
                            modal: false,
                            width: 640,
                            height: 500
                        });

                    }else if(action =='preview'){
                        var url = $(this).attr('dialog-url');
                        $.ajax({
                            type: 'GET',
                            dataType: 'json',
                            url: url,
                            success: function(data) {
                                console.log(data);
                                if(data != undefined && data.length > 0){
                                    $('#area-preview .page-name').html(pageName);
                                    $('#area-preview .area-content').html(JSON.parse(data));
                                    $("#area-preview" ).dialog({
                                         width : "90vw"
                                        ,modal:true
                                        ,maxWidth:'80vh'
                                        ,onOpen:function(){$('body').css('overflow', 'hidden');}
                                        ,onClose:function () {$('body').css('overflow', 'visible');}
                                    });
                                }
                            },
                            error:function (data) {
                                ConcreteAlert.error({
                                    title: '',
                                    message: data
                                });
                            },

                        })
                    }else if(action=='copy_to_clipboard'){

                        $.ajax({
                            type: 'GET',
                            dataType: 'json',
                            url: $(this).attr('dialog-url'),
                            success: function(data) {
                                ConcreteAlert.notify({
                                    'message': data.message,
                                });
                            },
                            error:function (data) {
                                ConcreteAlert.error({
                                    title: '',
                                    message: data.message
                                });
                            },

                        });
                    }

                });

            });
            $('body').click(function () {
                $('#pageContextMenu').hide();
                $('#areaContextMenu').hide();
            });
            function getMenuPosition(menuSelector, mouse, direction, scrollDir) {
                var win = $(window)[direction](),
                    scroll = $(window)[scrollDir](),
                    menu = $(menuSelector)[direction](),
                    position = mouse + scroll;

                // opening menu would pass the side of the page
                if (mouse + menu > win && menu < mouse)
                    position -= menu;

                return position;
            }
        };
        $('#tree').areasTree();

    });

</script>

<script type="text/template" id="areaContextMenuTemplate">
    <div id="areaContextMenu" class="popover fade" data-search-page-menu="" data-search-menu="">

        <div class="popover-inner">
            <ul class="dropdown-menu">
                <li><a data-action="delete" data-area-handle="<%=handle%>" href="javascript:void(0)"><?php echo t('Delete');?></a></li>
            </ul>
        </div>
    </div>
</script>
<script type="text/template" id="pageContextMenuTemplate">
    <div id="pageContextMenu" class="popover fade" data-search-page-menu="" data-search-menu="">

        <div class="popover-inner">
            <ul class="dropdown-menu">
                <%if(blocksCount > 0){%>
                <li><a data-action="preview" dialog-url="<?php echo $view->action('area_preview_html'); ?>/<%=areaHandle%>/<%=cID%>" data-page-name="<%=pageName%>" data-area-handle="<%=areaHandle%>" data-cID=<%=cID%>" href="javascript:void(0)"><?php echo t('View');?></a></li>
                <li><a data-action="copy_to_clipboard" dialog-url="<?php echo $view->action('copy_blocks'); ?>/<%=areaHandle%>/<%=cID%>" data-area-handle="<%=areaHandle%>" data-cID=<%=cID%>" href="javascript:void(0)"><?php echo t('Copy all bocks to clipboard')?></a> </li>
                <%}%>
                <li><a data-action="design" dialog-url="<?php echo URL::to('/ccm/system/dialogs/page/design');?>?cID=<%=cID%>" data-cID"<%=cID%>" href="javascript:void(0)"><?php echo t('Design and Type');?></a></li>
                <li><a data-action="" href="<%=url%>"><?php echo t('Visit');?></a></li>
            </ul>
        </div>
    </div>
</script>

<style>
    #area-preview{
        display: none;
        overflow-y: scroll!important;
        max-height: 90vh!important;
    }
    #tree .area-handle.bold{
        font-weight: bold;
    }
    #tree .page-name{
        font-weight: bold;
    }
    #tree .page-name.no-active-blocks{
        opacity: 0.8;
        font-weight: normal;
    }
    #tree .ui-fancytree{
        background: transparent;
    }
</style>